// Generated by zig-wayland

// Copyright 2021 Isaac Freund
// 
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
// 

// This protocol allows for a privileged Wayland client to lock the session
// and display arbitrary graphics while the session is locked.
// 
// The compositor may choose to restrict this protocol to a special client
// launched by the compositor itself or expose it to all privileged clients,
// this is compositor policy.
// 
// The client is responsible for performing authentication and informing the
// compositor when the session should be unlocked. If the client dies while
// the session is locked the session remains locked, possibly permanently
// depending on compositor policy.
// 
// Warning! The protocol described in this file is currently in the
// testing phase. Backward compatible changes may be added together with
// the corresponding interface version bump. Backward incompatible changes
// can only be done by creating a new major version of the extension.
// 

const common = @import("common.zig");pub const session_lock_manager_v1 = struct {
 extern const ext_session_lock_manager_v1_interface: common.Interface;
 pub inline fn getInterface() *const common.Interface {
  return &ext_session_lock_manager_v1_interface;
 }};pub const session_lock_v1 = struct {
 extern const ext_session_lock_v1_interface: common.Interface;
 pub inline fn getInterface() *const common.Interface {
  return &ext_session_lock_v1_interface;
 }pub const Error = enum(c_int) {invalid_destroy= 0,invalid_unlock= 1,role= 2,duplicate_output= 3,already_constructed= 4,_,};
};pub const session_lock_surface_v1 = struct {
 extern const ext_session_lock_surface_v1_interface: common.Interface;
 pub inline fn getInterface() *const common.Interface {
  return &ext_session_lock_surface_v1_interface;
 }pub const Error = enum(c_int) {commit_before_first_ack= 0,null_buffer= 1,dimensions_mismatch= 2,invalid_serial= 3,_,};
};