// Generated by zig-wayland

// Copyright 2021 Isaac Freund
// 
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
// 

// This protocol allows for a privileged Wayland client to lock the session
// and display arbitrary graphics while the session is locked.
// 
// The compositor may choose to restrict this protocol to a special client
// launched by the compositor itself or expose it to all privileged clients,
// this is compositor policy.
// 
// The client is responsible for performing authentication and informing the
// compositor when the session should be unlocked. If the client dies while
// the session is locked the session remains locked, possibly permanently
// depending on compositor policy.
// 
// Warning! The protocol described in this file is currently in the
// testing phase. Backward compatible changes may be added together with
// the corresponding interface version bump. Backward incompatible changes
// can only be done by creating a new major version of the extension.
// 

const os = @import("std").os;
const server = @import("wayland.zig").server;
const common = @import("common.zig");pub const SessionLockManagerV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.ext.session_lock_manager_v1.getInterface;pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*SessionLockManagerV1 {
    return @ptrCast(*SessionLockManagerV1, try server.wl.Resource.create(_client, SessionLockManagerV1, _version, _id));
}pub fn destroy(_session_lock_manager_v1: *SessionLockManagerV1) void {
    return @ptrCast(*server.wl.Resource, _session_lock_manager_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *SessionLockManagerV1 {
    return @ptrCast(*SessionLockManagerV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_session_lock_manager_v1: *SessionLockManagerV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _session_lock_manager_v1).getLink();
}pub fn getClient(_session_lock_manager_v1: *SessionLockManagerV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _session_lock_manager_v1).getClient();
}pub fn getId(_session_lock_manager_v1: *SessionLockManagerV1) u32 {
    return @ptrCast(*server.wl.Resource, _session_lock_manager_v1).getId();
}pub fn getVersion(_session_lock_manager_v1: *SessionLockManagerV1) u32 {
    return @ptrCast(*server.wl.Resource, _session_lock_manager_v1).getVersion();
}pub fn postNoMemory(_session_lock_manager_v1: *SessionLockManagerV1) void {
    return @ptrCast(*server.wl.Resource, _session_lock_manager_v1).postNoMemory();
}pub const Request = union(enum) {destroy: void,lock: struct {id:u32,},
};
pub inline fn setHandler(
    _session_lock_manager_v1: *SessionLockManagerV1,
    comptime T: type,
    handle_request: fn (_session_lock_manager_v1: *SessionLockManagerV1, request: Request, data: T) void,
    comptime handle_destroy: ?fn (_session_lock_manager_v1: *SessionLockManagerV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _session_lock_manager_v1);
    _resource.setDispatcher(
        common.Dispatcher(SessionLockManagerV1, T).dispatcher,
        handle_request,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*SessionLockManagerV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}};
pub const SessionLockV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.ext.session_lock_v1.getInterface;pub const Error = common.ext.session_lock_v1.Error;
pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*SessionLockV1 {
    return @ptrCast(*SessionLockV1, try server.wl.Resource.create(_client, SessionLockV1, _version, _id));
}pub fn destroy(_session_lock_v1: *SessionLockV1) void {
    return @ptrCast(*server.wl.Resource, _session_lock_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *SessionLockV1 {
    return @ptrCast(*SessionLockV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_session_lock_v1: *SessionLockV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _session_lock_v1).getLink();
}pub fn getClient(_session_lock_v1: *SessionLockV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _session_lock_v1).getClient();
}pub fn getId(_session_lock_v1: *SessionLockV1) u32 {
    return @ptrCast(*server.wl.Resource, _session_lock_v1).getId();
}pub fn getVersion(_session_lock_v1: *SessionLockV1) u32 {
    return @ptrCast(*server.wl.Resource, _session_lock_v1).getVersion();
}pub fn postNoMemory(_session_lock_v1: *SessionLockV1) void {
    return @ptrCast(*server.wl.Resource, _session_lock_v1).postNoMemory();
}pub fn postError(session_lock_v1: *SessionLockV1, _err: Error, _message: [*:0]const u8) void {
    return @ptrCast(*server.wl.Resource, session_lock_v1).postError(@intCast(u32, @enumToInt(_err)), _message);
}pub const Request = union(enum) {destroy: void,get_lock_surface: struct {id:u32,surface:*server.wl.Surface,output:*server.wl.Output,},
unlock_and_destroy: void,};
pub inline fn setHandler(
    _session_lock_v1: *SessionLockV1,
    comptime T: type,
    handle_request: fn (_session_lock_v1: *SessionLockV1, request: Request, data: T) void,
    comptime handle_destroy: ?fn (_session_lock_v1: *SessionLockV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _session_lock_v1);
    _resource.setDispatcher(
        common.Dispatcher(SessionLockV1, T).dispatcher,
        handle_request,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*SessionLockV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}pub fn sendLocked(_session_lock_v1: *SessionLockV1) void {const _resource = @ptrCast(*server.wl.Resource,_session_lock_v1);_resource.postEvent(0, null);}
pub fn sendFinished(_session_lock_v1: *SessionLockV1) void {const _resource = @ptrCast(*server.wl.Resource,_session_lock_v1);_resource.postEvent(1, null);}
};
pub const SessionLockSurfaceV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.ext.session_lock_surface_v1.getInterface;pub const Error = common.ext.session_lock_surface_v1.Error;
pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*SessionLockSurfaceV1 {
    return @ptrCast(*SessionLockSurfaceV1, try server.wl.Resource.create(_client, SessionLockSurfaceV1, _version, _id));
}pub fn destroy(_session_lock_surface_v1: *SessionLockSurfaceV1) void {
    return @ptrCast(*server.wl.Resource, _session_lock_surface_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *SessionLockSurfaceV1 {
    return @ptrCast(*SessionLockSurfaceV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_session_lock_surface_v1: *SessionLockSurfaceV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _session_lock_surface_v1).getLink();
}pub fn getClient(_session_lock_surface_v1: *SessionLockSurfaceV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _session_lock_surface_v1).getClient();
}pub fn getId(_session_lock_surface_v1: *SessionLockSurfaceV1) u32 {
    return @ptrCast(*server.wl.Resource, _session_lock_surface_v1).getId();
}pub fn getVersion(_session_lock_surface_v1: *SessionLockSurfaceV1) u32 {
    return @ptrCast(*server.wl.Resource, _session_lock_surface_v1).getVersion();
}pub fn postNoMemory(_session_lock_surface_v1: *SessionLockSurfaceV1) void {
    return @ptrCast(*server.wl.Resource, _session_lock_surface_v1).postNoMemory();
}pub fn postError(session_lock_surface_v1: *SessionLockSurfaceV1, _err: Error, _message: [*:0]const u8) void {
    return @ptrCast(*server.wl.Resource, session_lock_surface_v1).postError(@intCast(u32, @enumToInt(_err)), _message);
}pub const Request = union(enum) {destroy: void,ack_configure: struct {serial:u32,},
};
pub inline fn setHandler(
    _session_lock_surface_v1: *SessionLockSurfaceV1,
    comptime T: type,
    handle_request: fn (_session_lock_surface_v1: *SessionLockSurfaceV1, request: Request, data: T) void,
    comptime handle_destroy: ?fn (_session_lock_surface_v1: *SessionLockSurfaceV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _session_lock_surface_v1);
    _resource.setDispatcher(
        common.Dispatcher(SessionLockSurfaceV1, T).dispatcher,
        handle_request,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*SessionLockSurfaceV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}pub fn sendConfigure(_session_lock_surface_v1: *SessionLockSurfaceV1, _serial:u32, _width:u32, _height:u32) void {const _resource = @ptrCast(*server.wl.Resource,_session_lock_surface_v1);var _args = [_]common.Argument{.{ .u = _serial},.{ .u = _width},.{ .u = _height},};
_resource.postEvent(0, &_args);}
};
