// Generated by zig-wayland

// Copyright 2020 The River Developers
// 
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
// 

const os = @import("std").os;
const server = @import("wayland.zig").server;
const common = @import("common.zig");pub const ControlV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.zriver.control_v1.getInterface;pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*ControlV1 {
    return @ptrCast(*ControlV1, try server.wl.Resource.create(_client, ControlV1, _version, _id));
}pub fn destroy(_control_v1: *ControlV1) void {
    return @ptrCast(*server.wl.Resource, _control_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *ControlV1 {
    return @ptrCast(*ControlV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_control_v1: *ControlV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _control_v1).getLink();
}pub fn getClient(_control_v1: *ControlV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _control_v1).getClient();
}pub fn getId(_control_v1: *ControlV1) u32 {
    return @ptrCast(*server.wl.Resource, _control_v1).getId();
}pub fn getVersion(_control_v1: *ControlV1) u32 {
    return @ptrCast(*server.wl.Resource, _control_v1).getVersion();
}pub fn postNoMemory(_control_v1: *ControlV1) void {
    return @ptrCast(*server.wl.Resource, _control_v1).postNoMemory();
}pub const Request = union(enum) {destroy: void,add_argument: struct {argument:[*:0]const u8,},
run_command: struct {seat:*server.wl.Seat,callback:u32,},
};
pub inline fn setHandler(
    _control_v1: *ControlV1,
    comptime T: type,
    handle_request: fn (_control_v1: *ControlV1, request: Request, data: T) void,
    comptime handle_destroy: ?fn (_control_v1: *ControlV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _control_v1);
    _resource.setDispatcher(
        common.Dispatcher(ControlV1, T).dispatcher,
        handle_request,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*ControlV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}};
pub const CommandCallbackV1 = opaque {
 pub const generated_version = 1;
 pub const getInterface = common.zriver.command_callback_v1.getInterface;pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*CommandCallbackV1 {
    return @ptrCast(*CommandCallbackV1, try server.wl.Resource.create(_client, CommandCallbackV1, _version, _id));
}pub fn destroy(_command_callback_v1: *CommandCallbackV1) void {
    return @ptrCast(*server.wl.Resource, _command_callback_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *CommandCallbackV1 {
    return @ptrCast(*CommandCallbackV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_command_callback_v1: *CommandCallbackV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _command_callback_v1).getLink();
}pub fn getClient(_command_callback_v1: *CommandCallbackV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _command_callback_v1).getClient();
}pub fn getId(_command_callback_v1: *CommandCallbackV1) u32 {
    return @ptrCast(*server.wl.Resource, _command_callback_v1).getId();
}pub fn getVersion(_command_callback_v1: *CommandCallbackV1) u32 {
    return @ptrCast(*server.wl.Resource, _command_callback_v1).getVersion();
}pub fn postNoMemory(_command_callback_v1: *CommandCallbackV1) void {
    return @ptrCast(*server.wl.Resource, _command_callback_v1).postNoMemory();
}pub inline fn setHandler(
    _command_callback_v1: *CommandCallbackV1,
    comptime T: type,
    comptime handle_destroy: ?fn (_command_callback_v1: *CommandCallbackV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _command_callback_v1);
    _resource.setDispatcher(
        null,
        null,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*CommandCallbackV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}pub fn destroySendSuccess(_command_callback_v1: *CommandCallbackV1, _output:[*:0]const u8) void {const _resource = @ptrCast(*server.wl.Resource,_command_callback_v1);var _args = [_]common.Argument{.{ .s = _output},};
_resource.postEvent(0, &_args);_resource.destroy();}
pub fn destroySendFailure(_command_callback_v1: *CommandCallbackV1, _failure_message:[*:0]const u8) void {const _resource = @ptrCast(*server.wl.Resource,_command_callback_v1);var _args = [_]common.Argument{.{ .s = _failure_message},};
_resource.postEvent(1, &_args);_resource.destroy();}
};
