// Generated by zig-wayland

// Copyright 2020-2021 The River Developers
// 
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
// 

// This protocol specifies a way for clients to propose arbitrary positions
// and dimensions for a set of views on a specific output of a compositor
// through the river_layout_v3 object.
// 
// Layouts are a strictly linear list of views, the position and dimensions
// of which are supplied by the client. Any complex underlying data structure
// a client may use when generating the layout is lost in transmission. This
// is an intentional limitation.
// 
// Additionally, this protocol allows the compositor to deliver arbitrary
// user-provided commands associated with a layout to clients. A client
// may use these commands to implement runtime configuration/control, or
// may ignore them entirely. How the user provides these commands to the
// compositor is not specified by this protocol and left to compositor policy.
// 
// Warning! The protocol described in this file is currently in the
// testing phase. Backward compatible changes may be added together with
// the corresponding interface version bump. Backward incompatible changes
// can only be done by creating a new major version of the extension.
// 

const common = @import("common.zig");pub const layout_manager_v3 = struct {
 extern const river_layout_manager_v3_interface: common.Interface;
 pub inline fn getInterface() *const common.Interface {
  return &river_layout_manager_v3_interface;
 }};pub const layout_v3 = struct {
 extern const river_layout_v3_interface: common.Interface;
 pub inline fn getInterface() *const common.Interface {
  return &river_layout_v3_interface;
 }pub const Error = enum(c_int) {count_mismatch= 0,already_committed= 1,_,};
};