// Generated by zig-wayland

// Copyright 2020 The River Developers
// 
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
// 

const os = @import("std").os;
const server = @import("wayland.zig").server;
const common = @import("common.zig");pub const StatusManagerV1 = opaque {
 pub const generated_version = 4;
 pub const getInterface = common.zriver.status_manager_v1.getInterface;pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*StatusManagerV1 {
    return @ptrCast(*StatusManagerV1, try server.wl.Resource.create(_client, StatusManagerV1, _version, _id));
}pub fn destroy(_status_manager_v1: *StatusManagerV1) void {
    return @ptrCast(*server.wl.Resource, _status_manager_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *StatusManagerV1 {
    return @ptrCast(*StatusManagerV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_status_manager_v1: *StatusManagerV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _status_manager_v1).getLink();
}pub fn getClient(_status_manager_v1: *StatusManagerV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _status_manager_v1).getClient();
}pub fn getId(_status_manager_v1: *StatusManagerV1) u32 {
    return @ptrCast(*server.wl.Resource, _status_manager_v1).getId();
}pub fn getVersion(_status_manager_v1: *StatusManagerV1) u32 {
    return @ptrCast(*server.wl.Resource, _status_manager_v1).getVersion();
}pub fn postNoMemory(_status_manager_v1: *StatusManagerV1) void {
    return @ptrCast(*server.wl.Resource, _status_manager_v1).postNoMemory();
}pub const Request = union(enum) {destroy: void,get_river_output_status: struct {id:u32,output:*server.wl.Output,},
get_river_seat_status: struct {id:u32,seat:*server.wl.Seat,},
};
pub inline fn setHandler(
    _status_manager_v1: *StatusManagerV1,
    comptime T: type,
    handle_request: fn (_status_manager_v1: *StatusManagerV1, request: Request, data: T) void,
    comptime handle_destroy: ?fn (_status_manager_v1: *StatusManagerV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _status_manager_v1);
    _resource.setDispatcher(
        common.Dispatcher(StatusManagerV1, T).dispatcher,
        handle_request,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*StatusManagerV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}};
pub const OutputStatusV1 = opaque {
 pub const generated_version = 4;
 pub const getInterface = common.zriver.output_status_v1.getInterface;pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*OutputStatusV1 {
    return @ptrCast(*OutputStatusV1, try server.wl.Resource.create(_client, OutputStatusV1, _version, _id));
}pub fn destroy(_output_status_v1: *OutputStatusV1) void {
    return @ptrCast(*server.wl.Resource, _output_status_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *OutputStatusV1 {
    return @ptrCast(*OutputStatusV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_output_status_v1: *OutputStatusV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _output_status_v1).getLink();
}pub fn getClient(_output_status_v1: *OutputStatusV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _output_status_v1).getClient();
}pub fn getId(_output_status_v1: *OutputStatusV1) u32 {
    return @ptrCast(*server.wl.Resource, _output_status_v1).getId();
}pub fn getVersion(_output_status_v1: *OutputStatusV1) u32 {
    return @ptrCast(*server.wl.Resource, _output_status_v1).getVersion();
}pub fn postNoMemory(_output_status_v1: *OutputStatusV1) void {
    return @ptrCast(*server.wl.Resource, _output_status_v1).postNoMemory();
}pub const Request = union(enum) {destroy: void,};
pub inline fn setHandler(
    _output_status_v1: *OutputStatusV1,
    comptime T: type,
    handle_request: fn (_output_status_v1: *OutputStatusV1, request: Request, data: T) void,
    comptime handle_destroy: ?fn (_output_status_v1: *OutputStatusV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _output_status_v1);
    _resource.setDispatcher(
        common.Dispatcher(OutputStatusV1, T).dispatcher,
        handle_request,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*OutputStatusV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}pub fn sendFocusedTags(_output_status_v1: *OutputStatusV1, _tags:u32) void {const _resource = @ptrCast(*server.wl.Resource,_output_status_v1);var _args = [_]common.Argument{.{ .u = _tags},};
_resource.postEvent(0, &_args);}
pub fn sendViewTags(_output_status_v1: *OutputStatusV1, _tags:*common.Array) void {const _resource = @ptrCast(*server.wl.Resource,_output_status_v1);var _args = [_]common.Argument{.{ .a = _tags},};
_resource.postEvent(1, &_args);}
pub fn sendUrgentTags(_output_status_v1: *OutputStatusV1, _tags:u32) void {const _resource = @ptrCast(*server.wl.Resource,_output_status_v1);var _args = [_]common.Argument{.{ .u = _tags},};
_resource.postEvent(2, &_args);}
pub fn sendLayoutName(_output_status_v1: *OutputStatusV1, _name:[*:0]const u8) void {const _resource = @ptrCast(*server.wl.Resource,_output_status_v1);var _args = [_]common.Argument{.{ .s = _name},};
_resource.postEvent(3, &_args);}
pub fn sendLayoutNameClear(_output_status_v1: *OutputStatusV1) void {const _resource = @ptrCast(*server.wl.Resource,_output_status_v1);_resource.postEvent(4, null);}
};
pub const SeatStatusV1 = opaque {
 pub const generated_version = 3;
 pub const getInterface = common.zriver.seat_status_v1.getInterface;pub fn create(_client: *server.wl.Client, _version: u32, _id: u32) !*SeatStatusV1 {
    return @ptrCast(*SeatStatusV1, try server.wl.Resource.create(_client, SeatStatusV1, _version, _id));
}pub fn destroy(_seat_status_v1: *SeatStatusV1) void {
    return @ptrCast(*server.wl.Resource, _seat_status_v1).destroy();
}pub fn fromLink(_link: *server.wl.list.Link) *SeatStatusV1 {
    return @ptrCast(*SeatStatusV1, server.wl.Resource.fromLink(_link));
}pub fn getLink(_seat_status_v1: *SeatStatusV1) *server.wl.list.Link {
    return @ptrCast(*server.wl.Resource, _seat_status_v1).getLink();
}pub fn getClient(_seat_status_v1: *SeatStatusV1) *server.wl.Client {
    return @ptrCast(*server.wl.Resource, _seat_status_v1).getClient();
}pub fn getId(_seat_status_v1: *SeatStatusV1) u32 {
    return @ptrCast(*server.wl.Resource, _seat_status_v1).getId();
}pub fn getVersion(_seat_status_v1: *SeatStatusV1) u32 {
    return @ptrCast(*server.wl.Resource, _seat_status_v1).getVersion();
}pub fn postNoMemory(_seat_status_v1: *SeatStatusV1) void {
    return @ptrCast(*server.wl.Resource, _seat_status_v1).postNoMemory();
}pub const Request = union(enum) {destroy: void,};
pub inline fn setHandler(
    _seat_status_v1: *SeatStatusV1,
    comptime T: type,
    handle_request: fn (_seat_status_v1: *SeatStatusV1, request: Request, data: T) void,
    comptime handle_destroy: ?fn (_seat_status_v1: *SeatStatusV1, data: T) void,
    _data: T,
) void {
    const _resource = @ptrCast(*server.wl.Resource, _seat_status_v1);
    _resource.setDispatcher(
        common.Dispatcher(SeatStatusV1, T).dispatcher,
        handle_request,
        @intToPtr(?*anyopaque, @ptrToInt(_data)),
        if (handle_destroy) |_handler| struct {
            fn _wrapper(__resource: *server.wl.Resource) callconv(.C) void {
                @call(.{ .modifier = .always_inline }, _handler, .{
                    @ptrCast(*SeatStatusV1, __resource),
                    @intToPtr(T, @ptrToInt(__resource.getUserData())),
                });
            }
        }._wrapper else null,
    );
}pub fn sendFocusedOutput(_seat_status_v1: *SeatStatusV1, _output:*server.wl.Output) void {const _resource = @ptrCast(*server.wl.Resource,_seat_status_v1);var _args = [_]common.Argument{.{ .o = @ptrCast(*common.Object, _output) },};
_resource.postEvent(0, &_args);}
pub fn sendUnfocusedOutput(_seat_status_v1: *SeatStatusV1, _output:*server.wl.Output) void {const _resource = @ptrCast(*server.wl.Resource,_seat_status_v1);var _args = [_]common.Argument{.{ .o = @ptrCast(*common.Object, _output) },};
_resource.postEvent(1, &_args);}
pub fn sendFocusedView(_seat_status_v1: *SeatStatusV1, _title:[*:0]const u8) void {const _resource = @ptrCast(*server.wl.Resource,_seat_status_v1);var _args = [_]common.Argument{.{ .s = _title},};
_resource.postEvent(2, &_args);}
pub fn sendMode(_seat_status_v1: *SeatStatusV1, _name:[*:0]const u8) void {const _resource = @ptrCast(*server.wl.Resource,_seat_status_v1);var _args = [_]common.Argument{.{ .s = _name},};
_resource.postEvent(3, &_args);}
};
