// Generated by zig-wayland

// Copyright © 2019 Purism SPC
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice (including the next
// paragraph) shall be included in all copies or substantial portions of the
// Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
// 

// This protocol allows clients to control power management modes
// of outputs that are currently part of the compositor space. The
// intent is to allow special clients like desktop shells to power
// down outputs when the system is idle.
// 
// To modify outputs not currently part of the compositor space see
// wlr-output-management.
// 
// Warning! The protocol described in this file is experimental and
// backward incompatible changes may be made. Backward compatible changes
// may be added together with the corresponding interface version bump.
// Backward incompatible changes are done by bumping the version number in
// the protocol and interface names and resetting the interface version.
// Once the protocol is to be declared stable, the 'z' prefix and the
// version number in the protocol and interface names are removed and the
// interface version number is reset.
// 

const common = @import("common.zig");pub const output_power_manager_v1 = struct {
 extern const zwlr_output_power_manager_v1_interface: common.Interface;
 pub inline fn getInterface() *const common.Interface {
  return &zwlr_output_power_manager_v1_interface;
 }};pub const output_power_v1 = struct {
 extern const zwlr_output_power_v1_interface: common.Interface;
 pub inline fn getInterface() *const common.Interface {
  return &zwlr_output_power_v1_interface;
 }pub const Mode = enum(c_int) {off= 0,on= 1,_,};
pub const Error = enum(c_int) {invalid_mode= 1,_,};
};